/*
 *
 * Lezione 9
 *
 * Lettura da stdin di una sequenza di Persone con campi Nome, Cognome
 * ed Eta', e ordinamento rispetto al campo Cognome e, nel caso di
 * uguaglianza, al campo Nome. Il numero di Persone da leggere  fornito
 * come primo valore in input.
 *
 */


#include <stdio.h>
#include <stdlib.h>


/* Assumiamo che Nome e Cognome consistano di al piu' 256 chars. */
typedef struct {
  char Nome[256];
  char Cognome[256];
  int  Eta;
} Persona;



/* Confrontatore di Persone, da usare nel qsort() */
int ConfrPersone(const void *p1, const void *p2)
{
  Persona *pers1 = (Persona *) p1;
  Persona *pers2 = (Persona *) p2;

  /* Calcola l'ordinamento per Cognome e Nome */
  int r1 = strcmp(pers1->Cognome,pers2->Cognome);
  int r2 = strcmp(pers1->Nome,pers2->Nome);
 
  /* Confronta prima il Cognome e poi il Nome, se necessario */
  if (!r1) return r2; // se il cognome  uguale, restituisco il risultato r2 del confronto sui nomi 
  else return r1;     // se il cognome  diverso, r1 fornisce il risultato

}



int main()
{
  int i; /* variabile di appoggio */
  int N; /* Numero di persone da leggere */
  Persona *ArrayPersone; /* Array di persone */

  printf("Immettere n.ro persone da ordinare:\n");
  scanf("%d", &N); /* Numero di persone */

  /* Alloca il vettore che conterra' le persone lette da stdin */
  ArrayPersone = (Persona *) malloc(sizeof(Persona) * N);

  /* Legge da stdin */
  printf("Immettere Nome, Cognome ed Eta di %d persone\n",N); 
  for ( i = 0; i < N; i++ ) 
      {
	scanf("%s", ArrayPersone[i].Nome);
	scanf("%s", ArrayPersone[i].Cognome);
	scanf("%d", &(ArrayPersone[i].Eta));
      }

  /* Ordina secondo il Cognome e poi il Nome */
  qsort(ArrayPersone, N, sizeof(Persona), ConfrPersone);

  /* Stampa a video il risultato dell'ordinamento */
  for( i=0; i<N; i++)
    printf("Nome: %s, Cognome: %s, Eta': %d\n", 
	   ArrayPersone[i].Nome, ArrayPersone[i].Cognome, ArrayPersone[i].Eta);

  return 0;
}
